package jp.oarts.pirka.tools.properties;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.HashMap;

/**
 * ȈՃvpeBNX
 * 
 * @version $Revision: 1.4 $ $Date: 2010/11/10 10:02:20 $
 * 
 * @author S.ito Oriental-Arts
 * 
 */
public class EasyProperties extends HashMap<String, String> {

	/**	 */
	private static final long serialVersionUID = 1L;

	/**
	 * RXgN^
	 */
	public EasyProperties() {

	}

	/**
	 * t@CvpeB擾
	 * 
	 * @param fileName
	 *            t@C
	 * @throws FileNotFoundException
	 *             t@C݂Ȃ
	 * @throws IOException
	 *             I/OG[
	 */
	public void loadFile(String fileName) throws FileNotFoundException, IOException {
		load(new FileInputStream(fileName));
	}

	/**
	 * \[XvpeB擾
	 * 
	 * @param resourceName
	 * @throws IOException
	 */
	public void loadResource(String resourceName) throws IOException {
		
		
		URL url = getClass().getClassLoader().getResource(resourceName);
		if (url == null) {
			throw new IOException("\[Xt@C܂ " + resourceName);
		}
		load(url.openStream());
	}

	/**
	 * InputStrream胊\[X擾
	 * 
	 * @param is
	 *            InputStrream
	 * @throws IOException
	 */
	public void load(InputStream is) throws IOException {

		BufferedReader br = null;

		try {
			br = new BufferedReader(new InputStreamReader(is));
			while (true) {
				String line = br.readLine();
				if (line == null) {
					break;
				}

				int index = line.indexOf("=");
				if (index <= 0) {
					continue;
				}

				String key = line.substring(0, index).trim();
				String value = "";
				if ((index + 1) < line.length()) {
					value = line.substring(index + 1).trim();
				}

				if (key.length() > 0 && key.charAt(0) != '#' && key.charAt(0) != '!') {
					put(key, value);
				}
			}
		} finally {
			if (br != null) {
				br.close();
			}
		}
	}

//-------------------------------------------------------------------------------
	
	public static void main(String[] args) {
		EasyProperties ep = new EasyProperties();
		try{
			ep.loadFile("C:/Users/amano/Desktop/HySUT.properties");
			String value = ep.get("ftp.username");
			System.out.println(value);
		}catch(IOException e){
			e.printStackTrace();
		}
	}
}
