package jp.oarts.pirka.tools.properties;

import java.io.IOException;

/**
 * vWFNgpvpeB擾NX
 * 
 * @version $Revision: 1.2 $ $Date: 2010/11/05 08:24:16 $
 * 
 * @author S.ito Oriental-Arts
 * 
 */
public class ProjectProperties {

	/** vpeB */
//	private String propertieName;
	
	private static String resourceName;


	/** vpeB */
	private static EasyProperties easyProperties = null;

	/**
	 * vpeBt@ClēǍ
	 */
	public static void refresh() throws IOException {
		synchronized (ProjectProperties.class) {
			load();
		}
	}

	/**
	 * vpeBt@Cw肳ꂽvpeBɑΉ镶̒l擾B
	 * 
	 * @param name
	 *            vpeB
	 * @return l
	 */
	public static String getString(String name) throws IOException {
		EasyProperties properties = getEasyProperties();
		String value = properties.get(name);
		if (value == null) {
			return "";
		}
		return value.trim();
	}

	/**
	 * vpeBt@Cw肳ꂽvpeBɑΉ镶̒l擾B<br>
	 * AΉl݂Ȃ̓ftHgl߂B
	 * 
	 * @param name
	 *            vpeB
	 * @param defaultValue
	 *            ftHgl
	 * @return l
	 */
	public static String getString(String name, String defaultValue) throws IOException {
		String value = getString(name);

		if (value.length() > 0) {
			return value;
		}
		return defaultValue;
	}

	/**
	 * vpeBt@Cw肳ꂽvpeBɑΉ鐔liIntegerj擾B
	 * 
	 * @param name
	 *            vpeB
	 * @return l(vpeB݂Ȃnull)
	 */
	public static Integer getInt(String name) throws IOException {
		try {
			return Integer.parseInt(getString(name));
		} catch (NumberFormatException e) {
			return null;
		}
	}

	/**
	 * vpeBt@Cw肳ꂽvpeBɑΉ鐔liIntegerj擾B<br>
	 * AΉl݂ȂA܂͐lȊO̓ftHgl߂B
	 * 
	 * @param name
	 *            vpeB
	 * @param defaultValue
	 *            ftHgl
	 * @return l
	 */
	public static Integer getInt(String name, int defaultValue) throws IOException {
		Integer value = getInt(name);
		if (value == null) {
			return defaultValue;
		}

		return value;
	}

	/**
	 * vpeBt@Cw肳ꂽvpeBɑΉ鐔liLongj擾B
	 * 
	 * @param name
	 *            vpeB
	 * @return l(vpeB݂Ȃnull)
	 */
	public static Long getLong(String name) throws IOException {
		try {
			return Long.parseLong(getString(name));
		} catch (NumberFormatException e) {
			return null;
		}
	}

	/**
	 * vpeBt@Cw肳ꂽvpeBɑΉ鐔liLongj擾B<br>
	 * AΉl݂ȂA܂͐lȊO̓ftHgl߂B
	 * 
	 * @param name
	 *            vpeB
	 * @param defaultValue
	 *            ftHgl
	 * @return l
	 */
	public static Long getLong(String name, long defaultValue) throws IOException {
		Long value = getLong(name);
		if (value == null) {
			return defaultValue;
		}

		return value;
	}

	/**
	 * ȈՃvpeB̎擾
	 * 
	 * @return ȈՃvpeB
	 */
	private static EasyProperties getEasyProperties() throws IOException {
		synchronized (ProjectProperties.class) {
			if (easyProperties == null) {
				load();
			}
			return easyProperties;
		}
	}

	/**
	 * vpeBt@CvpeB[h
	 */
	private static void load() throws IOException {
		easyProperties = new EasyProperties();

		easyProperties.loadResource(resourceName);

	}

	/**
	 * @param resourceName the resourceName to set
	 */
	public static void setResourceName(String resourceName) {
		ProjectProperties.resourceName = resourceName;
	}
	
	public static void main(String[] args) {
	}

}
