package jp.oarts.pirka.tools.util;

import java.text.NumberFormat;
import java.text.ParseException;
import java.util.StringTokenizer;

import jp.oarts.pirka.core.util.check.Checker;
import jp.oarts.pirka.core.util.check.PirkaCheckException;
import jp.oarts.pirka.core.util.check.PirkaChecker;

public class DataFormat {
	
	/**
	 * w肳ꂽ񂪍ő啶ɖȂꍇA̍͐擪Ɂu0vǉ
	 * @param value 
	 * @param max ő啶
	 * @return u0v[Uϕ
	 */
	public static String insertZero(String value, int max) {
		//error Ȃ
		if (value==null || value.length()<1){
			return "";
		}
		
		StringBuilder sb = new StringBuilder();
		sb.append(value);
		for(int i=value.length(); i<max; i++) {
			sb.insert(0,"0"); 
		}
		return sb.toString();
	}
	
	/**
	 * w肳ꂽ񂪍ő啶ɖȂꍇA̍̓Xy[X
	 * @param value 
	 * @param max ő啶
	 * @return Xy[X[Uϕ
	 */
	public static String addSpace(String value, int max) {
		//error Ȃ
		if (value==null || value.length()<1){
			return "";
		}
		StringBuilder sb = new StringBuilder();
		sb.append(value);
		for(int i=value.length(); i<max; i++) {
			sb.append(" ");
		}
		return value;
	}
	
	/**
	 * zAf[^lɑ΂ϊ\bh
	 * ́A擪̂݋e
	 * @param String value
	 * @return `f[^ ( 1000  1,000Ȃ )AϊłȂƂ́Â܂ܕԂ
	 */	
	public static String formatAddComma(String value) {
		String ret = value;
		//error Ȃ
		if (value==null || value.length()<1) {
			return ret;	
		}
		//error lȊO
		StringBuilder sb = new StringBuilder();
		String checkValue = value.trim();
		
		boolean hasPeriod = false; //_L
		boolean hasSign = false;//L
		String sign = null;// 
		int signPosition = 0;//Ȃ=0,O=1,㕄=9 
		boolean isError = false;
		for (int i=0; i<checkValue.length(); i++) {
			char c=checkValue.charAt(i);
			if (c >= '0' && c <= '9') {
				sb.append(c);
			} else if (c=='.') { 
				isError = true;
				if (!hasPeriod) {	//_oH
					hasPeriod = true;
					sb.append(c);
					isError = false;
				}
			} else if (c=='-' || c=='+') {
				isError = true;
				if (!hasSign){	//oH
					if (i==0 || i==checkValue.length()-1){	//擪orH
						hasSign = true;
						sign = String.valueOf(c);
						if (i==0){
							signPosition = 1;
							isError = false;
						} else {
							signPosition = 9;
							isError = false;
						}
					}
				}
			}
			//G[Ƃ́A߂
			if (isError){
				return value;
			}
		}
        Checker checker = PirkaChecker.numeric;
		try {
			// lϊ\ǂ̃`FbN
			checker.check(sb.toString());
			//񔽓]
			String reverseStr = sb.reverse().toString();
			StringBuilder reverseSb = new StringBuilder();
			
			// _̈ʒu`FbN
			int periodPosition = 0;
			if (hasPeriod){
				periodPosition = reverseStr.indexOf(".")+1;
			}
			
			int cnt = 0;
			for (int i=0;i<reverseStr.length();i++){
				char c = reverseStr.charAt(i);
				if (i<periodPosition){	// _̈ʒu܂ł́Â܂ܒǉ
					reverseSb.append(c);
				}else{					// _ȍ~́A3ƂɃJ}ǉ
					reverseSb.append(c);
					cnt = cnt +1;
					if(cnt%3==0 && i !=(reverseStr.length()-1)){
						reverseSb.append(",");
					}
				}
			}
			sb = reverseSb.reverse();
			
			if (hasSign) {	// t̂Ƃ́Äʒuɖ߂
				switch (signPosition){
				case 1:
					ret = sign + sb.toString();
					break;
				case 9:
					ret = sb.toString() + sign;
					break;
				} 
			} else {
				ret =  sb.toString();
			}
		} catch (PirkaCheckException e) {
			ret = value;
		}
		
		return ret;
		
	}

	/**
	 * J}ҏWꂽ񂩂J}
	 * lȊÔ̕Ƃ́AnullԂ
	 * @param value
	 * @return
	 */
	public static String removeComma(String value){
		if (value==null || value.length()<1){
			return null;
		}

		StringBuilder sb = new StringBuilder();
		for (int i=0;i<value.length();i++){
			if (value.charAt(i)!=','){
				sb.append(value.charAt(i));
			}
		}

		String ret = sb.toString();
        Checker checker = PirkaChecker.numeric;
		try {
			checker.check(ret);
		} catch (PirkaCheckException e) {
			ret = null;
		}
        return ret;
	}
	
	
//-----------------------------------------------------------------------------------	
	public static void main(String[] args) {
//		System.out.println(insertZero("100",5));
		System.out.println("1 : " + formatAddComma("1"));
		System.out.println("11 : " + formatAddComma("11"));
		System.out.println("101 : " + formatAddComma("101"));
		System.out.println("1001 : " + formatAddComma("1001"));
		System.out.println("10001 : " + formatAddComma("10001"));
		System.out.println("100001 : " + formatAddComma("100001"));
		System.out.println("1000001 : " + formatAddComma("1000001"));
		System.out.println("10000001 : " + formatAddComma("10000001"));
		System.out.println("100000001 : " + formatAddComma("100000001"));
		System.out.println("-1000001 : " + formatAddComma("-1000001"));
		System.out.println("-10000001 : " + formatAddComma("-10000001"));
		System.out.println("-100000001 : " + formatAddComma("-100000001"));
		System.out.println("+1000001 : " + formatAddComma("+1000001"));
		System.out.println("+10000001 : " + formatAddComma("+10000001"));
		System.out.println("+100000001 : " + formatAddComma("+100000001"));
		System.out.println("1.01 : " + formatAddComma("1.01"));
		System.out.println("10.01 : " + formatAddComma("10.01"));
		System.out.println("100.01 : " + formatAddComma("100.01"));
		System.out.println("1000.01 : " + formatAddComma("1000.01"));
		System.out.println("10000.01 : " + formatAddComma("10000.01"));
		System.out.println("100000.01 : " + formatAddComma("100000.01"));
		System.out.println("1000000.01 : " + formatAddComma("1000000.01"));
		System.out.println("1a000001 : " + formatAddComma("1a000001"));
		System.out.println("1-000001 : " + formatAddComma("1-000001"));
		System.out.println("1+000001 : " + formatAddComma("1+000001"));
		System.out.println("10000.010101 : " + formatAddComma("10000.010101"));
		System.out.println("10.000.01 : " + formatAddComma("10.000.01"));
		System.out.println("1000001- : " + formatAddComma("1000001-"));
		System.out.println("1000001+ : " + formatAddComma("1000001+"));
		System.out.println("-1000001- : " + formatAddComma("-1000001-"));
		System.out.println("+1000001- : " + formatAddComma("+1000001-"));
		System.out.println("+10000.010101 : " + formatAddComma("+10000.010101"));
		System.out.println("-10000.010101 : " + formatAddComma("-10000.010101"));
		System.out.println("10000.010101+ : " + formatAddComma("10000.010101+"));
		System.out.println("10000.010101- : " + formatAddComma("10000.010101-"));
		System.out.println("+10000.010101- : " + formatAddComma("+10000.010101-"));


//		System.out.println(removeComma("1,000,000"));
//		System.out.println(removeComma("1,000,000.00"));
//		System.out.println(removeComma("1,000,000ab"));
//		System.out.println(removeComma(null));

	}
}
