package jp.oarts.pirka.tools.util;

import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashSet;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * tϊ[eBeB
 * 
 * @author oa
 * 
 */
public class DateConverter {
	
	private static char[] checkChar = {'0','1','2','3','4','5','6','7','8','9','/',':','.','N','','','','','b','-',' '};
	private static HashSet checkCharSet = new HashSet();
	static {
		for (char c:checkChar){
			checkCharSet.add(c);	
		}
	}

	/**
	 * EttH[}b^(Type1) util.Date  yyyyMMdd
	 */
    public static String dateFormatType1(java.util.Date value){
		String returnValue = "";

		DateFormat dateformat = new SimpleDateFormat("yyyyMMdd");

		if (value != null) {
			returnValue = dateformat.format(value);
		}

		return returnValue;
    }
	
	
	/**
	 * EttH[}b^(Type2) util.Date  yyyy/MM/dd
	 */
    public static String dateFormatType2(java.util.Date value){
		String returnValue = "";

		DateFormat dateformat = new SimpleDateFormat("yyyy/MM/dd");

		if (value != null) {
			returnValue = dateformat.format(value);
		}

		return returnValue;
    }

	/**
	 * EttH[}b^(Type3) util.Date  yyyy-MM-dd
	 */
    public static String dateFormatType3(java.util.Date value){
		String returnValue = "";

		DateFormat dateformat = new SimpleDateFormat("yyyy-MM-dd");

		if (value != null) {
			returnValue = dateformat.format(value);
		}

		return returnValue;
    }


	/**
	 * EttH[}b^(Type4) util.Date  yyyyNMMdd
	 */
    public static String dateFormatType4(java.util.Date value){
		String returnValue = "";

		DateFormat dateformat = new SimpleDateFormat("yyyyNMMdd");

		if (value != null) {
			returnValue = dateformat.format(value);
		}

		return returnValue;
    }

	/**
	 * EttH[}b^(Type5) util.Date  yyyy/MM/dd HH:mm:ss
	 */
    public static String dateFormatType5(java.util.Date value){
		String returnValue = "";

		DateFormat dateformat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");

		if (value != null) {
			returnValue = dateformat.format(value);
		}

		return returnValue;
    }

	/**
	 * EttH[}b^(Type6) util.Date  yyyy-MM-dd HH:mm:ss
	 */
    public static String dateFormatType6(java.util.Date value){
		String returnValue = "";

		DateFormat dateformat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

		if (value != null) {
			returnValue = dateformat.format(value);
		}

		return returnValue;
    }

	/**
	 * EttH[}b^(Type7) util.Date  yyyyNMMdd HHmmssb
	 */
    public static String dateFormatType7(java.util.Date value){
		String returnValue = "";

		DateFormat dateformat = new SimpleDateFormat("yyyyNMMdd HHmmssb");

		if (value != null) {
			returnValue = dateformat.format(value);
		}

		return returnValue;
    }

	/**
	 * Eutil.Date  sql.Dateϊ
	 */
    public static java.sql.Date utilDateToSqlDate(java.util.Date value){
		if (value == null) {
			return null;
		}
    	java.sql.Date returnValue = new java.sql.Date(value.getTime());
    	return returnValue;
    }
    
	/**
	 * Esql.Date  util.Dateϊ
	 */
    public static java.util.Date sqlDateToUtilDate(java.sql.Date value){
		if (value == null) {
			return null;
		}
    	java.util.Date returnValue = new java.util.Date(value.getTime());
    	return returnValue;
    }
    
	/**
	 * EString  util.Dateϊ
	 */
	public static java.util.Date strToUtilDate(String value) {
		if (value == null || value.length()==0) {
			return null;
		}
		
		try {
			value = format(value);
			// yyyy/MM/dd hh:mm:ss
			if(value.length() > 10){
				return new java.util.Date((new SimpleDateFormat("yyyy/MM/dd HH:mm:ss")).parse(value).getTime());
			}
			return new java.util.Date((new SimpleDateFormat("yyyy/MM/dd")).parse(value).getTime());
		} catch (ParseException e) {
			return null;
		}
	}
	/**
	 * ECalendar  util.Dateϊ
	 */
	public static java.util.Date calToUtilDate(Calendar value) {
		if (value == null) {
			return null;
		}
		return new java.util.Date(value.getTimeInMillis());
	}
	
	/**
	 * Eutil.Date  Calendarϊ
	 */
	public static Calendar utilDateToCal(java.util.Date value) {
		if (value == null) {
			return null;
		}
        Calendar returnValue =Calendar.getInstance();
        returnValue.clear();
        returnValue.setTime(value); 
        return returnValue;
	}
	/**
	 * ETimestamp  util.Dateϊ
	 */
	public static java.util.Date timestampToUtilDate(Timestamp value) {
		if (value == null) {
			return null;
		}
		return new java.util.Date(value.getTime());
	}

	/**
	 * Eutil.Date  Timestampϊ
	 */
	public static Timestamp utilDateToTimestamp(java.util.Date value) {
		if (value == null) {
			return null;
		}
        return new Timestamp(value.getTime());
	}
	
	/**
	 * lXȓtAftHg̓tEtH[}bg
	 * ֕ϊ܂B
	 * 
	 * ftHg̓ttH[}bg͈ȉɂȂ܂B
	 *     t̏ꍇFyyyy/MM/dd
	 *     t+̏ꍇFyyyy/MM/dd HH:mm:ss.SSS
	 * 
	 * @param str ϊΏۂ̕
	 * @return ftHg̓tEtH[}bg
	 * @throws IllegalArgumentException 
	 *     t񂪕ϊs\ȏꍇ 
	 */
	private static String format(String value)throws ParseException{
		String returnValue = "";
		// \Ă镶̃`FbN
		//  / - : . N     b
		for (int i=0;i<value.length();i++){
			char c = value.charAt(i);
			checkCharSet.contains(c);
			if (!checkCharSet.contains(c)){
				throw new ParseException(value, 0);
			}
		}

		// yyyy/MM/dd HH:mm:ss.SSS `ɍv悤ɕu
		value = value.replaceAll("-", "/");
		value = value.replaceAll("N", "/");
		value = value.replaceAll("", "/");
		value = value.replaceAll("", "");
		value = value.replaceAll("", ":");
		value = value.replaceAll("", ":");
		value = value.replaceAll("b", ".");
		// uʂ̍ŏI :. ̂Ƃ͏
		String lastChar = value.substring(value.length()-1);
		if (lastChar.compareTo(":")==0 || lastChar.compareTo(".")==0) {
			value = value.substring(0,value.length()-1);
		}
		// ŏ̕(N)4ɂȂĂȂƂ͕␳(1200x,220xx)
		int w = value.indexOf("/");
		if (w == 1) {
			value = "200" + value;
		} else if (w==2){
			value = "20" + value;
		}
		//tƂĐǂ̃`FbN
		SimpleDateFormat ymd = new SimpleDateFormat("yyyy/MM/dd");
		SimpleDateFormat ymdhms = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss.SSS");
		
		if (value.indexOf(":") > 0) {
			Pattern pattern1 = Pattern.compile(":");
			Matcher matcher1 = pattern1.matcher(value);
	        int hitCount = 0;
	        while (matcher1.find()) {
	            hitCount++;
	        }
	        if (hitCount==1){
	        	value = value + ":00";
	        }
	        if (value.indexOf(".") < 0) {
	        	value = value + ".000";
	        }
	        
	        returnValue = ymdhms.format(ymdhms.parse(value));
		} else {
			
			returnValue = ymd.format(ymd.parse(value));
		}
		return returnValue;
	}

	
    public static void main(String[] args) {
    	java.util.Date utilDate = new java.util.Date();
    	Calendar cal = Calendar.getInstance();
    	java.sql.Date sqlDate = new java.sql.Date(utilDate.getTime());
    	Timestamp time = new Timestamp(cal.getTimeInMillis());
    	System.out.println(" EttH[}b^(Type1) util.Date  yyyyMMdd");
    	System.out.println("\t" + dateFormatType1(utilDate));
    	System.out.println(" EttH[}b^(Type2) util.Date  yyyy/MM/dd");
    	System.out.println("\t" + dateFormatType2(utilDate));
    	System.out.println(" EttH[}b^(Type3) util.Date  yyyy-MM-dd");
    	System.out.println("\t" + dateFormatType3(utilDate));
    	System.out.println(" EttH[}b^(Type4) util.Date  yyyyNMMdd");
    	System.out.println("\t" + dateFormatType4(utilDate));
    	System.out.println(" EttH[}b^(Type5) util.Date  yyyy/MM/dd hh:mm:ss");
    	System.out.println("\t" + dateFormatType5(utilDate));
    	System.out.println(" EttH[}b^(Type6) util.Date  yyyy-MM-dd hh:mm:ss");
    	System.out.println("\t" + dateFormatType6(utilDate));
    	System.out.println(" EttH[}b^(Type7) util.Date  yyyyNMMdd hhmmssb");
    	System.out.println("\t" + dateFormatType7(utilDate));
    	System.out.println(" Eutil.Date  sql.Dateϊ");
    	System.out.println("\t" + utilDateToSqlDate(utilDate));
    	System.out.println(" Esql.Date  util.Dateϊ");
    	System.out.println("\t" + sqlDateToUtilDate(sqlDate));
    	
     	System.out.println();
    	
    	System.out.println(" EString  util.Dateϊ");
    	System.out.println("\t" + "" + " = " + strToUtilDate(""));
    	System.out.println("\t" + "abcde" + " = " + strToUtilDate("abcde"));
    	System.out.println("\t" + "12345" + " = " + strToUtilDate("12345"));
    	System.out.println("\t" + "201011" + " = " + strToUtilDate("201011"));
    	System.out.println("\t" + "2010/1/1" + " = " + strToUtilDate("2010/1/1"));
    	System.out.println("\t" + "2010N11" + " = " + strToUtilDate("2010N11"));
    	System.out.println("\t" + dateFormatType1(utilDate) + " = " + strToUtilDate(dateFormatType1(utilDate)));
    	System.out.println("\t" + dateFormatType2(utilDate) + " = " + strToUtilDate(dateFormatType2(utilDate)));
    	System.out.println("\t" + dateFormatType3(utilDate) + " = " + strToUtilDate(dateFormatType3(utilDate)));
    	System.out.println("\t" + dateFormatType4(utilDate) + " = " + strToUtilDate(dateFormatType4(utilDate)));
    	System.out.println("\t" + dateFormatType5(utilDate) + " = " + strToUtilDate(dateFormatType5(utilDate)));
    	System.out.println("\t" + dateFormatType6(utilDate) + " = " + strToUtilDate(dateFormatType6(utilDate)));
    	System.out.println("\t" + dateFormatType7(utilDate) + " = " + strToUtilDate(dateFormatType7(utilDate)));
    
    	System.out.println();
    	
    	System.out.println(" EcalToDate(Calendar)");
    	System.out.println("\t" + calToUtilDate(cal));
    	System.out.println(" Eutil.Date  Calendarϊ");
    	System.out.println("\t" + utilDateToCal(utilDate).get(Calendar.YEAR) + " " + utilDateToCal(utilDate).get(Calendar.MONTH) + " " + utilDateToCal(utilDate).get(Calendar.DATE));
    	System.out.println(" ETimestamp  util.Dateϊ");
    	System.out.println("\t" + timestampToUtilDate(time));
    	System.out.println(" Eutil.Date  Timestampϊ");
    	System.out.println("\t" + utilDateToTimestamp(utilDate));

    	System.out.println("01:"+ strToUtilDate("2010/11/09"));
		System.out.println("02:"+ strToUtilDate("2010-11-09"));
		System.out.println("03:"+ strToUtilDate("2010N1109"));
		System.out.println("04:"+ strToUtilDate("2010/11/09 10:11"));
		System.out.println("05:"+ strToUtilDate("2010/11/09 10:11:12"));
		System.out.println("06:"+ strToUtilDate("2010/11/09 10:11:12.134"));
		System.out.println("07:"+ strToUtilDate("2010/11/09 1011"));
		System.out.println("08:"+ strToUtilDate("2010/11/09 101112b"));
		System.out.println("09:"+ strToUtilDate("2010/11/09 101112b123"));
		System.out.println("10:"+ strToUtilDate("10/11/09"));
		System.out.println("11:"+ strToUtilDate("5/1/9"));
		System.out.println("12:"+ strToUtilDate("2010/11/09a"));
		System.out.println("13:"+ strToUtilDate("2010/1/9 0:1:2"));

    
    }

}
