package jp.oarts.pirka.tools.util;

import java.util.Arrays;
import java.util.HashMap;

/**
 * String[eBeB
 * @author oa
 *
 */
public class StringUtil {

	private static final char[] HANKAKU_KANA = {'', '', '', '', '',
		'', '', '', '', '', '', '', '', '', '', '', 
		'', '','', '', '', '', '', '', '', '', 
		'', '', '', '', '','', '', '', '', '', 
		'', '', '', '', '', '', '', '','', '', 
		'', '', '', '', '', '', '', '', 
		'', '', '','', '', '', '', '', '' };
	
	private static final char[] ZENKAKU_KANA = {'B', 'u', 'v', 'A', 'E',
		'', '@', 'B', 'D', 'F', 'H', '', '', '', 'b', '[', 
		'A', 'C','E', 'G', 'I', 'J', 'L', 'N', 'P', 'R', 
		'T', 'V', 'X', 'Z', '\','^', '`', 'c', 'e', 'g', 
		'i', 'j', 'k', 'l', 'm', 'n', 'q', 't','w', 'z', 
		'}', '~', '', '', '', '', '', '', 
		'', '', '','', '', '', '', 'J', 'K' };


	private static final char[] HANKAKU_ALPHANUM = {'0','1','2','3','4','5',
		'6','7','8','9','A','B','C','D','E','F','G','H','I','J','K','L','M',
		'N','O','P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d',
		'e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u',
		'v','w','x','y','z'
	};
	
	private static final char[] ZENKAKU_ALPHANUM = {'O','P','Q','R','S','T',
		'U','V','W','X','`','a','b','c','d','e','f','g','h','i','j','k','l',
		'm','n','o','p','q','r','s','t','u','v','w','x','y','','','','',
		'','','','','','','','','','','','','','','','','',
		'','','','',''
	};
	private static final HashMap ZEN_TO_HAN = new HashMap();
	private static final HashMap HAN_TO_ZEN = new HashMap();
	private static final HashMap ZEN_TO_HAN_KANA = new HashMap();
	private static final HashMap HAN_TO_ZEN_KANA = new HashMap();
	static {
		for (int i=0;i<HANKAKU_ALPHANUM.length;i++){
			char c = HANKAKU_ALPHANUM[i];
			char zC = ZENKAKU_ALPHANUM[i];
			HAN_TO_ZEN.put(c, zC);
			ZEN_TO_HAN.put(zC, c);
		}
		for (int i=0;i<HANKAKU_KANA.length;i++){
			char c = HANKAKU_KANA[i];
			char zC = ZENKAKU_KANA[i];
			HAN_TO_ZEN_KANA.put(c, zC);
			ZEN_TO_HAN_KANA.put(zC, c);
		}
	}
	
	/**
	 * ̑Oォ甼p/SpXy[X菜
	 * null̎́AuNԂ
	 * @param value
	 * @return
	 */
	public static String trim(String value){
		if (value == null || value.length() < 1) {
			return "";
		}
		int len = value.length();
		int st  = 0;
		char[] val = value.toCharArray();
		
		//擪甼p/SpXy[XJEg
		while (st < len && (val[st]<= ' ' || val[st] == '@')){
			st++;
		}
		//甼p/SpXy[XJEg
		while (st < len && (val[len - 1]<= ' ' || val[len - 1] == '@')) {
			len--;
		}
		//擪/̃Xy[X
		if (st>0 || len < value.length()){
			return value.substring(st,len);
		}
		return value;
	}
	
	/**
	 * At@xbg p  p啶 ϊ@toUpperCase
	 * null̂Ƃ́AuNԂ
	 * @param value
	 * @return
	 */
	public static String toUpperCase(String value){
		if (value==null) {
			return "";
		}
		return value.toUpperCase();
	}
	
	/**
	 * At@xbg p啶  p ϊ@toLowerCase
	 * null̂Ƃ́AuNԂ
	 * @param value
	 * @return
	 */
	public static String toLowerCase(String value){
		if (value==null) {
			return "";
		}
		return value.toLowerCase();
	}
	
	/**
	 * pp  Spp ϊ
	 * p̉p[a-zA-Z],[0-9]Spɒu
	 * null̂Ƃ́AuNԂ
	 * @param value
	 * @return
	 */
	public static String hankakuToZenkaku(String value){
		if (value==null) {
			return "";
		}
		StringBuilder sb = new StringBuilder();
		for (int i=0;i<value.length();i++){
			char c = value.charAt(i);
			if (HAN_TO_ZEN.containsKey(c)) {
				char zC =  (Character) HAN_TO_ZEN.get(c);
				sb.append(zC);
			} else {
				sb.append(c);
			}
		}
		return sb.toString();
		
	}

	/**
	 * Spp  pp ϊ
	 * Sp̉p[-`-y],[O-X]𔼊pɒu
	 * null̂Ƃ́AuNԂ
	 * @param value
	 * @return
	 */
	public static String zenkakuToHankaku(String value){
		if (value==null) {
			return "";
		}
		StringBuilder sb = new StringBuilder();
		for (int i=0;i<value.length();i++){
			char c = value.charAt(i);
			if (ZEN_TO_HAN.containsKey(c)) {
				char hC =  (Character) ZEN_TO_HAN.get(c);
				sb.append(hC);
			} else {
				sb.append(c);
			}
		}
		return sb.toString();
		
	}

	/**
	 * pJ^Ji  SpJ^Ji ϊ(String)
	 * @param value
	 * @return
	 */
	public static String hankakuToZenkakuKatakana(String value){
		if (value==null || value.length()==0) {
			return "";
		}
		
		if (value.length()==1){
			return hankakuToZenkakuKatakana(value.charAt(0))+"";
		}
		
		StringBuilder sb = new StringBuilder();
		
		int i = 0;
		for (i = 0;i<value.length()-1;i++){
			char c1 = value.charAt(i);
			char c2 = value.charAt(i+1);
			char c3 = composeChar(c1, c2);
			// 
			if (c3 != c1){
				sb.append(c3);
				i++;
			} else {
				char c4 = hankakuToZenkakuKatakana(c1);
				if (c4 != c1) {
					sb.append(c4);
				} else {
					sb.append(c1);
				}
			}
		}
		
		if (i < value.length()){
			char c1 = value.charAt(i);
			char c4 = hankakuToZenkakuKatakana(c1);
			if (c4 != c1) {
				sb.append(c4);
			} else {
				sb.append(c1);
			}
		}
		
		return sb.toString();
	}
	
	/**
	 * pJ^Ji  SpJ^Ji ϊ(char)
	 * @param c
	 * @return
	 */
	private static char hankakuToZenkakuKatakana(char c){
		char zC = c;
		if (HAN_TO_ZEN_KANA.containsKey(c)) {
			zC =  (Character) HAN_TO_ZEN_KANA.get(c);
		} else {
			//zC = c;
		}
		return zC;
	}

	/**
	 * _E_̍
	 * @param c1
	 * @param c2
	 * @return
	 */
	private static char composeChar(char c1, char c2) {
		if (c2 == '') {
			if ("".indexOf(c1) >= 0) {
				switch (c1) {
				case '': return '';
				case '': return 'K';
				case '': return 'M';
				case '': return 'O';
				case '': return 'Q';
				case '': return 'S';
				case '': return 'U';
				case '': return 'W';
				case '': return 'Y';
				case '': return '[';
				case '': return ']';
				case '': return '_';
				case '': return 'a';
				case '': return 'd';
				case '': return 'f';
				case '': return 'h';
				case '': return 'o';
				case '': return 'r';
				case '': return 'u';
				case '': return 'x';
				case '': return '{';
				}
			}
		} else if (c2 == '') {
			if ("".indexOf(c1) > 0) {
				switch (c1) {
				case '': return 'p';
				case '': return 's';
				case '': return 'v';
				case '': return 'y';
				case '': return '|';
				}
			}
		}
		return c1;
	}

	/**
	 * SpJ^Ji  pJ^Ji ϊ(String)
	 * @param value
	 * @return
	 */
	public static String zenkakuToHankakuKatakana(String value){
		StringBuilder sb = new StringBuilder();
		for (int i=0;i<value.length();i++){
			char c = value.charAt(i);
			sb.append(devideChar(c));
		}
		return sb.toString();
	}
	/**
	 * JiSppu_E_̕
	 * @param c1
	 * @param c2
	 * @return
	 */
	private static String devideChar(char c1) {
		switch (c1) {
		case '': return "";
		case 'K': return "";
		case 'M': return "";
		case 'O': return "";
		case 'Q': return "";
		case 'S': return "";
		case 'U': return "";
		case 'W': return "";
		case 'Y': return "";
		case '[': return "";
		case ']': return "";
		case '_': return "";
		case 'a': return "";
		case 'd': return "";
		case 'f': return "";
		case 'h': return "";
		case 'o': return "";
		case 'r': return "";
		case 'u': return "";
		case 'x': return "";
		case '{': return "";
		case 'p': return "";
		case 's': return "";
		case 'v': return "";
		case 'y': return "";
		case '|': return "";
		}
		
		if (ZEN_TO_HAN_KANA.containsKey(c1)){
			return String.valueOf(ZEN_TO_HAN_KANA.get(c1));
		}
	return String.valueOf(c1);
	}

	/**
	 * null̎́AuNԂ
	 * @param value
	 * @return
	 */
	public static String stringNullChange(String value){
		if (value == null || value.length() < 1) {
			return "";
		}
		return value;
	}
	
	// SpXy[X  pXy[X ϊ
	// wbyte̕쐬(Ƃ͐؂AŌ̕}`oCg̓r͍̎폜ĔpXy[X߁AZƂ͔pXy[X)
	// JEg
	// URL`FbJ
	// [AhX`FbJ
	
//------- TEST ----------------------------------
	
	public static void main(String[] args){
		System.out.println("*** TEST START ***");
		System.out.println("trim(null) :" + trim(null) + ":");
		System.out.println("trim(uN) :" + trim("") + ":");
		System.out.println("trim(abc def     ) :" + trim("abc def     ") + ":");
		System.out.println("trim(   abc def     ) :" + trim("   abc def     ") + ":");
		System.out.println("trim(SpXy[Xabc defSpXy[X) :" + trim("@abc def@") + ":");
		//
		System.out.println("toUpperCase(null) :" + toUpperCase(null) + ":");
		System.out.println("toUpperCase(abc) :" + toUpperCase("abc") + ":");
		//
		System.out.println("toLowerCase(null) :" + toLowerCase(null) + ":");
		System.out.println("toLowerCase(ABC) :" + toLowerCase("ABC") + ":");
		//
		System.out.println("hankakuToZenkaku(ABCabc123) :" + hankakuToZenkaku("ABCabc123") + ":");
		//
		System.out.println("zenkakuToHankaku(`abPQR) :" + zenkakuToHankaku("`abPQR") + ":");
		//
		System.out.println("hankakuToZenkakuKatakana(PG:۸ϰ,SE:ѴݼƱ,ާ) :" + hankakuToZenkakuKatakana("PG:۸ϰ,SE:ѴݼƱ,ާ") + ":");
		//
		System.out.println("zenkakuToHankakuKatakana(PG:vO}[,SE:VXeGWjA,@CI) :" + zenkakuToHankakuKatakana("PG:vO}[,SE:VXeGWjA,@CI") + ":");
		
	}
}
